% LABORATIORIO 2: ES 1

clear all 
close all
clc

A=[-4 0 -3;
    0 -2 -1;
    0 -2 -3];

B= [0 0 1]'; %[0;0;1];

C=[1 0 0];

D  = 0;

%% punto A

% IL SISTEMA  LTI -> propriet globali

% stabilit di un LTI dipende dai movimenti liberi (quindi solo da matrice
% A)

% det(lambda*I-A)=0 -> autovalori

autovalori=eig(A);

if sum((real(autovalori)<0))==length(autovalori)
    disp('sistema AS')
elseif sum((real(autovalori)>0))>0
    disp('sistema instabile')
elseif sum((real(autovalori)<=0))==length(autovalori) && sum((real(autovalori)==0))==1
    disp('sistema stabile')
else
    disp('instabile o stabile: verificare molteplicit algebrica e geometrica degli autovalori')

end

%% punto B

% guadagno statico ha senso parlarne solo se il sistema  AS 

% y_reg/u_reg=dcgain

% x_reg/u_reg=dcgain

% xdot=Ax+Bu;

% 0=Ax_reg+Bu_reg; 
% 
% x_reg=-A^-1B*u_reg;

% y_reg=Cx_reg+D*u_reg=-CA^-1Bu_reg+D*u_reg=(-CA^-1B+D)*u_reg;

% dc_gain=(-CA^-1B+D);

mu_analitico=(-C*A^-1*B+D)


sist=ss(A,B,C,D);
mu_matlab=dcgain(sist)



%y=y_l+y_forzata 

%y_l=x0*e(A*t)->0
%y_f non dipende da x0 ma dipende da U e questo tende sempre al
%dc_gain*u_cost

%% punto C

% lsim puoi specificare tutto 
% step di apmpiezza unitaria partendo da x0=0


[y_step,t_step] = step(sist);

figure(1)
plot(t_step,y_step,'LineWidth',4)
hold on
plot(t_step,mu_matlab*ones(length(t_step),1),'-.','LineWidth',4)
title('risposta scalino')
xlabel('time [s]')
ylabel('output')
legend('output','dcgain')



%% punto D

% sin(5pit)

% si tracci il movimento forzato dell'uscita tra 0 e 5 sec. quando u(t) = sin(5pi*t). Si determini se
% esso si assesta su un movimento periodico.

t_sim_sin=0:0.01:20;
u_sin=sin(5*pi*t_sim_sin);
u_sin_bias=sin(5*pi*t_sim_sin)+1; %sin + step

x0=[0 0 0]';
[y_sin,t_sin]=lsim(sist, u_sin, t_sim_sin, x0);
[y_sin_bias,t_sin_bias]=lsim(sist, u_sin_bias, t_sim_sin, x0);

figure(2)
plot(t_sin,y_sin,'LineWidth',4)
hold on
plot(t_sin_bias,y_sin_bias,'LineWidth',4)
plot(t_sin_bias,mu_matlab*ones(length(t_sin_bias),1),'-.','LineWidth',4)

title('risposta sinusoidale')
xlabel('time [s]')
ylabel('output')
legend('sin','sin+bias','dcgain')



%% punto E 
[y_imp,t_imp] = impulse(sist);
figure(3)
plot(t_imp,y_imp,'LineWidth',4)
title('risposta impulsiva')
xlabel('time [s]')
ylabel('output')





